package app.brest.testmin3d;
import android.app.Activity;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.PixelFormat;
import android.hardware.Camera;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.View;
import android.view.ViewTreeObserver;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.MediaController;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.VideoView;

import org.w3c.dom.Text;

import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

import app.brest.app.brest.ui.CameraPreview;
import app.brest.utils.JSONLoader;
import app.brest.utils.ResourceManager;
import app.brest.utils.SensorsManager;
import app.brest.utils.app.brest.game.Game;
import app.brest.utils.app.brest.game.LocatedResource;
import app.brest.utils.app.brest.game.Place;
import app.brest.utils.app.brest.game.Resource;
import app.brest.utils.app.brest.game.Stage;
import app.brest.utils.geometry.GPSPoint;
import min3d.core.Object3d;
import min3d.core.Object3dContainer;
import min3d.core.RendererActivity;
import min3d.parser.IParser;
import min3d.parser.Parser;
import min3d.vos.CameraVo;
import min3d.vos.Light;
import min3d.vos.Number3d;


public class ARActivity extends RendererActivity
{

    private CameraPreview mImageSurfaceView;
    private Camera camera;
    private FrameLayout cameraPreviewLayout;

    private Object3dContainer faceObject3D;
    private Button mOkButton;
    private TextView mAngle;
    private TextView mGps;
    private final Object mLock = new Object();
    protected boolean isPausing=false;
    protected static GPSPoint mLocation;
    protected static boolean mLocationUpdated=false;
    protected TextView mTvDistance;
    protected TextView mTvAngle;
    protected TextView mTvGPS;
    protected RelativeLayout mRlRoot;
    protected ImageView mIvWhite;
    protected ImageView mIvRed;
    protected ImageView mIvGreen;
    protected ImageView mIvNone;
    protected int mViewWidth;
    protected int mViewHeight;
    protected boolean mDetect=false;
    protected boolean mInArea=false;
    private Game mGame;

    private Handler mCustomHandler = new Handler();

    public void init()
    {
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);


        cameraPreviewLayout = (FrameLayout)findViewById(R.id.camera_preview);

        camera = checkDeviceCamera();
        mImageSurfaceView = new CameraPreview(ARActivity.this, camera);

        mAngle = (TextView) findViewById(R.id.angle);
        mGps = (TextView) findViewById(R.id.gps);


        mOkButton = (Button) findViewById(R.id.button_catch);
        mOkButton.setVisibility(View.INVISIBLE);
        if(cameraPreviewLayout.getChildCount()<2)
        {
            cameraPreviewLayout.addView(_glSurfaceView,0);
            cameraPreviewLayout.addView(mImageSurfaceView,0);
        }

    }

    private Camera checkDeviceCamera() {
        Camera mCamera = null;
        try {
            mCamera = Camera.open();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mCamera;
    }

    protected void onCreateSetContentView()
    {
        //init();

    }

    @Override
    protected void glSurfaceViewConfig()
    {
        // !important
        _glSurfaceView.setEGLConfigChooser(8,8,8,8, 16, 0);
        _glSurfaceView.getHolder().setFormat(PixelFormat.TRANSLUCENT);
    }

    @Override
    public void initScene()
    {
        // !important
        scene.clear();
        scene.backgroundColor().setAll(0x00000000);
        scene.lights().add(new Light());
        scene.lights().add(new Light());

        Light myLight = new Light();
        myLight.position.setZ(150);
        scene.lights().add(myLight);


        //IParser myParser = Parser.createParser(Parser.Type.OBJ, getResources(), "app.brest.testmin3d:raw/face_obj", true);
        //myParser.parse();



    }

    protected Number3d pos(float deltaAngle, int _radius)
    {
        float radius = _radius;
        return new Number3d((float)(radius*Math.sin(deltaAngle)),
                            0,
                            (float)(15+radius*Math.cos(deltaAngle))
                        );
    }

    private Runnable updateTimerThread = new Runnable() {

        public void run() {
            mCustomHandler.postDelayed(this, 10);
        }

    };

    protected long mLedPeriode=0;
    protected long mLedLastTick=0;
    protected boolean mLedState=false;
    protected void updateLed(boolean detected,  double dist)
    {
        //si detecte
        if(detected)
        {
            mIvWhite.getHandler().post(new Runnable() { public void run() {mIvWhite.setVisibility(View.VISIBLE);}});
            mIvGreen.getHandler().post(new Runnable() { public void run() {mIvGreen.setVisibility(View.VISIBLE);}});
            mIvRed.getHandler().post(new Runnable() { public void run() {mIvRed.setVisibility(View.INVISIBLE);}});
            mInArea=mDetect=true;
        }
        //si dans une zone
        else if(dist>=0)
        {
            if(dist<5) mLedPeriode=5;
            else if(dist>=5 && dist<50) mLedPeriode=(int)((dist-4)*10);
            else mLedPeriode=500;
            if(System.currentTimeMillis()>mLedLastTick+mLedPeriode)
            {
                mLedLastTick=System.currentTimeMillis();
                if(mLedState)
                {
                    mLedState=false;
                    mIvWhite.getHandler().post(new Runnable() { public void run() {mIvWhite.setVisibility(View.INVISIBLE);}});
                }else
                {
                    mLedState=true;
                    mIvWhite.getHandler().post(new Runnable() { public void run() {mIvWhite.setVisibility(View.VISIBLE);}});
                }
            }

            mIvGreen.getHandler().post(new Runnable() { public void run() {mIvGreen.setVisibility(View.INVISIBLE);}});
            mIvRed.getHandler().post(new Runnable() { public void run() {mIvRed.setVisibility(View.VISIBLE);}});
            mInArea=true;
            mDetect=false;
        }
        //si rien
        else
        {
            mIvWhite.getHandler().post(new Runnable() { public void run() {mIvWhite.setVisibility(View.INVISIBLE);}});
            mIvGreen.getHandler().post(new Runnable() { public void run() {mIvGreen.setVisibility(View.INVISIBLE);}});
            mIvRed.getHandler().post(new Runnable() { public void run() {mIvRed.setVisibility(View.INVISIBLE);}});
            mInArea=mDetect=false;
        }
    }

    protected boolean updateSceneResource()
    {

        ArrayList<LocatedResource> res = mGame.getResourcesNextToPlayer();
        final TextView tv = (TextView) findViewById(R.id.text_detected);
        final TextView tv2 = (TextView)findViewById(R.id.text_place);
        String toDisplay ="Detetected \n";
        boolean detected = false;
       // String dete = "Detected:\n";
        scene.clear();
        for (int i = 0; i < res.size(); i++) {
            Resource rr = res.get(i).getResource();
            Place p = res.get(i).getPlace();
            if(rr!=null) {
                detected=true;
                toDisplay += "\t" + rr.getName() + " \n";
                //dete += "\t" + rr.getName() + "\n";
                Object3d oo = rr.get3DModel(this);
                CameraVo v = new CameraVo();

                v.target.y=mGame.getPlayer().getOrientationY()-315;

                //si utilisation de field et angle
                if(p.isUseAngle())
                    v.target.x=(float)(mGame.getPlayer().getOrientationX()-p.getAngle())+mGame.getPlayer().getOrientationZ()-270f;
                //si utilisation GPS pour l'angle
                else
                    v.target.x=(float)(mGame.getPlayer().getOrientationX()-mGame.getPlayer().getAngleWith(p))
                            +mGame.getPlayer().getOrientationZ()-270f;

                toDisplay += "    "+(float)(mGame.getPlayer().getAngleWith(p)) +"("+mGame.getPlayer().getXWith(p)+", "+mGame.getPlayer().getYWith(p) +")\n";
                //v.target.z=mGame.getPlayer().getOrientationZ()-270;
                scene.camera(v);
                scene.addChild(oo);
            }
        }

        updateLed(detected, mGame.getResourcesNextToPlayerDistDouble());


        final String td = toDisplay;
        /*mAngle.getHandler().post(new Runnable() {
            public void run() {
                tv2.setText(td);
            }
        });*/

        final String dete2 = mGame.getResourcesNextToPlayerDist();
        tv.getHandler().post(new Runnable() {
            public void run() {
                tv.setText(dete2);
            }
        });
        mTvDistance.getHandler().post(new Runnable() {
            public void run() {
                mTvDistance.setText(dete2);
            }
        });


        return scene.numChildren()>0;
    }

    protected void onList()
    {
        Intent intent = new Intent(this, ARActivity.class);
        intent.putExtra("game", mGame);
        startActivity(intent);
    }

    protected void moveView(View v, int x, int y, int w, int h)
    {
        RelativeLayout.LayoutParams l = new RelativeLayout.LayoutParams(w, h);
        l.leftMargin = x;
        l.topMargin = y;
        v.setLayoutParams(l);
    }


     @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        //mGame = (Game) getIntent().getSerializableExtra("game");
        mGame = Game.game();
        mGame.newSensorManager(this);
        mTvDistance=(TextView)findViewById(R.id.tv_distance);
        mTvAngle=(TextView)findViewById(R.id.tv_angle);
        mTvGPS=(TextView)findViewById(R.id.tv_gps);
        mRlRoot=(RelativeLayout) findViewById(R.id.rl_root);
        mIvWhite=(ImageView)findViewById(R.id.iv_white);
        mIvRed=(ImageView)findViewById(R.id.iv_red);
        mIvGreen=(ImageView)findViewById(R.id.iv_green);
        mIvNone=(ImageView)findViewById(R.id.iv_none);



        ViewTreeObserver vto = mRlRoot.getViewTreeObserver();
        vto.addOnGlobalLayoutListener(new ViewTreeObserver.OnGlobalLayoutListener() {
            @Override
            public void onGlobalLayout() {
                mRlRoot.getViewTreeObserver().removeGlobalOnLayoutListener(this);
                int w =mViewWidth  = mRlRoot.getMeasuredWidth();
                int h =mViewHeight = mRlRoot.getMeasuredHeight();

                mTvGPS.setTextSize((int)(h*0.121f/6));
                mTvGPS.setText("N ?°\nE ?°");
                mTvAngle.setTextSize((int)(h*0.121f/6));
                mTvDistance.setTextSize((int)(h*0.046f/1.8));

                moveView(mTvAngle, (int)(0.03*w), (int)(0.864f*h), (int)(0.291f*w), (int)(0.121*h ));
                moveView(mTvGPS, w-(int)(0.297f*w), (int)(0.875f*h),(int)(0.291f*w), (int)(0.121*h));
                moveView(mTvDistance, w-mTvDistance.getWidth()-(int)(0.359f*w), (int)(0.038f*h), mTvGPS.getWidth(), (int)(0.121*h));

                moveView(mIvNone, (int)(w/4.0), 0, (int)(w/2.0), (int)(0.06f*h));
                moveView(mIvWhite, (int)(w*0.269), (int)(0.034*h), (int)(w*0.03333), (int)(0.02286f*h));
                moveView(mIvRed, (int)(w*0.702), (int)(0.034*h), (int)(w*0.03333), (int)(0.02286f*h));
                moveView(mIvGreen, (int)(w*0.702), (int)(0.034*h), (int)(w*0.03333), (int)(0.02286f*h));
            }
        });



        Log.e("_________", "MrlRoot="+mIvRed.getWidth()+" et "+mIvRed.getHeight());
        int w = mRlRoot.getWidth();
        int h = mRlRoot.getHeight();


    }




    @Override
    /**
     * Verifie si on doit afficher des resources et gere le bouton de capture
     */
    public  void updateScene()
    {
        boolean isResource = false;
        synchronized (mLock) {
            if (!isPausing) {
                boolean b = mGame.precache3DResource(this);
                isResource = updateSceneResource();
                if(b)
                {
                    final Activity _this = this;
                    mAngle.getHandler().post(new Runnable() {
                        public void run() {
                            Toast.makeText(_this,"Localisé dans la zone", Toast.LENGTH_LONG);
                        }
                    });

                }
            }else
            {
                scene.clear();
                mGame.removeCached3DModels();
            }
        }

        if(isResource) {
            mOkButton.getHandler().post(new Runnable() {
                public void run() {
                    mOkButton.setVisibility(View.VISIBLE);
                }
            });
        }else
        {
            mOkButton.getHandler().post(new Runnable() {
                public void run() {
                    mOkButton.setVisibility(View.INVISIBLE);
                }
            });

        }
        mTvAngle.getHandler().post(new Runnable() {
            public void run() {
                NumberFormat formatter = new DecimalFormat("#0.0");
                mTvAngle.setText("X : "+formatter.format(mGame.getPlayer().getOrientation())+"°\nY : "+
                        formatter.format(mGame.getPlayer().getOrientationY())
                                +"°\nZ : "+formatter.format(mGame.getPlayer().getOrientationZ())+"°");
            }
        });

        setGpsText();

    }


    @Override
    protected  void onResume() {
        super.onResume();
        init();
        mGame.onResume(this);
        scene.clear();
        synchronized (mLock)
        {
            isPausing=false;
        }
    }
    @Override
    protected  void onPause()
    {
        synchronized (mLock)
        {
            isPausing=true;
        }
        super.onPause();
        mGame.onPause(this);
        scene.clear();
        cameraPreviewLayout.removeViewAt(0);
        cameraPreviewLayout.removeViewAt(0);

    }

    public void finish()
    {
        mGame.stopSensors();
        super.finish();
    }

    public void setGpsText()
    {
        if(mLocationUpdated) {
            final GPSPoint gps = mLocation;
            mTvGPS.getHandler().post(new Runnable() {

                public void run() {

                    NumberFormat formatter = new DecimalFormat("#0.0000000");
                    mTvGPS.setText("N "+formatter.format(gps.getX()) + "°\nE " + formatter.format(gps.getY()) + "°\n");
                }
            });
            mLocationUpdated=false;
        }
    }


    public void onSaveInstanceState(Bundle savedInstanceState) {
        // Save the user's current game state
        savedInstanceState.putSerializable("game", mGame);

        // Always call the superclass so it can save the view hierarchy state
        super.onSaveInstanceState(savedInstanceState);
    }

    public void onClickPickUp(View v)
    {
        Resource res = null;
        boolean stageFinished = mGame.pickResource();
        boolean finished = false;
        res=mGame.getLatestResource();


        if(stageFinished)
        {
           finished = mGame.nextStage();
            Log.e("--____", "Finished="+finished);
        }

        if(finished)
        {
            Log.e("Finished", "Finished");
        }

        if(stageFinished)
        {
            Stage s = mGame.getCurrentStageObj();
            Resource stageRes = s.getResource();

            if(finished)
            {
                Log.e("--____", "Here");
                Intent intent2 = new Intent(this, EndActivity.class);
                startActivity(intent2);
            }

            Intent intent = new Intent(this, ViewerActivity.class);
            intent.putExtra("resource", stageRes );
            startActivity(intent);

            Intent intent2 = new Intent(this, TransferActivity.class);
            startActivity(intent2);
        }

        Intent intent = new Intent(this, ViewerActivity.class);
        intent.putExtra("resource", res );
        startActivity(intent);
        finish();
    }


    public static void setLocation(GPSPoint p)
    {
        mLocation = p;
        mLocationUpdated=true;
    }



}
